/**
 * Created by richie on 15/11/23.
 */
;(function ($) {
    $.extend(FS.Design.op, {

        15879: function (designContainer) {
            FS.Plugin.LogAdmin.init(designContainer);
        }
    });

    FS.Plugin.LogAdmin = {

        init: function (render) {
            var items = [
                {text: "com.mysql.jdbc.Driver", value: "com.mysql.jdbc.Driver"},
                {text: "oracle.jdbc.driver.OracleDriver", value: "oracle.jdbc.driver.OracleDriver"},
                {
                    text: "com.microsoft.sqlserver.jdbc.SQLServerDriver",
                    value: "com.microsoft.sqlserver.jdbc.SQLServerDriver"
                }
            ];
            var saveHandler = function () {
                var driver = this.setting.getWidgetByName('driver');
                var url = this.setting.getWidgetByName('url');
                var username = this.setting.getWidgetByName('username');
                var password = this.setting.getWidgetByName('password');
                FR.ajax({
                    url: FR.servletURL + '?op=plugin_logdb&cmd=write',
                    data: {
                        driver: driver.getValue(),
                        url: url.getValue(),
                        username: username.getValue(),
                        password: password.getValue()
                    },
                    success: function (responseText) {
                        var data = FR.jsonDecode(responseText);
                        if (data.status == 'success') {
                            FR.Msg.toast(FR.i18nText('Plugin-Logdb_Save_OK'));
                        } else {
                            FR.Msg.toast(FR.i18nText("Plugin-Logdb_Save_Error"));
                        }
                    }
                });
            };
            var testHandler = function() {
                var driver = this.setting.getWidgetByName('driver');
                var url = this.setting.getWidgetByName('url');
                var username = this.setting.getWidgetByName('username');
                var password = this.setting.getWidgetByName('password');
                FR.ajax({
                    url : FR.servletURL + '?op=plugin_logdb&cmd=test',
                    data: {
                        driver: driver.getValue(),
                        url: url.getValue(),
                        username: username.getValue(),
                        password: password.getValue()
                    },
                    success : function(responseText) {
                        var data = FR.jsonDecode(responseText);
                        if (data.status == 'success') {
                            FR.Msg.toast('测试连接成功');
                        } else {
                            FR.Msg.toast('测试连接失败');
                        }
                    }
                });
            };
            var conf = {
                type: 'tablepane',
                rowSize: [24, 24, 24, 24, 24, 24],
                colSize: [20, 120, 400, 20, 80],
                vgap: 20,
                items: [
                    [{}, {}, {}],
                    [{type: 'llabel'}, {type: 'llabel', value: '驱动'}, {
                        type: 'combo',
                        widgetName: 'driver',
                        items: items
                    }],
                    [{type: 'llabel'}, {type: 'llabel', value: '数据库地址'}, {type: 'text', widgetName: 'url'}, {}, {}],
                    [{type: 'llabel'}, {type: 'llabel', value: '用户名'}, {type: 'text', widgetName: 'username'}, {}, {}],
                    [{type: 'llabel'}, {type: 'llabel', value: '密码'}, {type: 'password', widgetName: 'password'}, {}, {}],
                    [{type: 'llabel'}, {}, {
                        type: 'quickbutton',
                        text: '提交',
                        style: 'blue',
                        handler: saveHandler.createDelegate(this)
                    }, {}, {
                        type: 'quickbutton',
                        text: '测试连接',
                        style: 'green',
                        handler: testHandler.createDelegate(this)
                    }]
                ],
                renderEl: render,
                width: 700,
                height: 400
            };
            var setting = this.setting = new FS.TablePane(conf);
            FR.ajax({
                url: FR.servletURL + '?op=plugin_logdb&cmd=read',
                success: function (responseText) {
                    var data = FR.jsonDecode(responseText);
                    if (data.status == 'success') {
                        setting.getWidgetByName('driver').setValue(data.driver);
                        setting.getWidgetByName('url').setValue(data.url);
                        setting.getWidgetByName('username').setValue(data.username);
                        setting.getWidgetByName('password').setValue(data.password);
                    } else {
                        FR.Msg.toast('读取原始值时发生了未知错误');
                    }
                }
            });
        }

    };

})(jQuery);